#!/bin/bash

mkdir -p results/trials_sept24

# GoogleNews-vectors-negative300.bin.gz.1

for i in {0..2}
do
    for d in MR TREC SST1 SST2 SUBJ CR MPQA
    do
        # Conv
        python run.py --gpu 0 --model static --epoch 30 --dataset ${d} > results/trials_sept24/conv_${d}_${i}.log

        # FC
        python run.py --gpu 0 --model static --fc --epoch 30 --dataset ${d} > results/trials_sept24/fc_${d}_${i}.log

        # KOP warm start
        python run.py --gpu 0 --model static --kop --warm_start --epoch 30 --dataset ${d} > results/trials_sept24/kop_ws_${d}_${i}.log

        # KOP from scratch
        python run.py --gpu 0 --model static --kop --epoch 30 --dataset ${d} > results/trials_sept24/kop_fs_${d}_${i}.log
    done
done
